package cz.muni.pv239.wishlist.activities

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import androidx.navigation.NavController
import androidx.navigation.findNavController
import androidx.navigation.ui.AppBarConfiguration
import androidx.navigation.ui.setupActionBarWithNavController
import androidx.navigation.ui.setupWithNavController
import com.google.android.material.bottomnavigation.BottomNavigationView
import cz.muni.pv239.wishlist.R
import cz.muni.pv239.wishlist.databinding.ActivityLogInRegistrationBinding


class LogInRegistrationActivity : AppCompatActivity() {

    private lateinit var binding: ActivityLogInRegistrationBinding
    private lateinit var navController: NavController

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityLogInRegistrationBinding.inflate(layoutInflater)
        setContentView(binding.root)

        val navView: BottomNavigationView = binding.navView2
        navController = findNavController(R.id.frameLayout)
        val appBarConfiguration = AppBarConfiguration(
            setOf(
                R.id.navigation_log_in
            )
        )

        setupActionBarWithNavController(navController, appBarConfiguration)
        navView.setupWithNavController(navController)

        navView.visibility = View.GONE
    }

    override fun onSupportNavigateUp(): Boolean {
        if (binding.loginRegistrationLoadingView.visibility == View.VISIBLE) {
            return false
        }
        return navController.navigateUp() || super.onSupportNavigateUp()
    }

    fun changeVisibilityLoadingScreen(isVisible: Boolean) {
        binding.loginRegistrationLoadingView.visibility = if (isVisible) View.VISIBLE else View.GONE
    }
}