package cz.muni.pv239.wishlist.database

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import cz.muni.pv239.wishlist.database.daos.MyWishlistDao
import cz.muni.pv239.wishlist.database.daos.SharedWishlistItemDao
import cz.muni.pv239.wishlist.database.daos.SharedWishlistDao
import cz.muni.pv239.wishlist.database.entities.MyWishlistEntity
import cz.muni.pv239.wishlist.database.entities.SharedWishlistItemEntity
import cz.muni.pv239.wishlist.database.entities.SharedWishlistEntity

@Database(
    entities = [MyWishlistEntity::class,
               SharedWishlistEntity::class,
               SharedWishlistItemEntity::class],
    version = 6,
    exportSchema = false
)
abstract class WishlistDatabase : RoomDatabase() {

    companion object {
        private const val NAME = "consumption.db"

        fun create(context: Context): WishlistDatabase =
            Room.databaseBuilder(context, WishlistDatabase::class.java, NAME)
                .allowMainThreadQueries()
                .fallbackToDestructiveMigration()
                .build()
    }

    abstract fun myWishlistDao(): MyWishlistDao
    abstract fun sharedWishlistDao(): SharedWishlistDao
    abstract fun sharedItemDao(): SharedWishlistItemDao
}