package cz.muni.pv239.wishlist.database.daos

import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import androidx.room.Transaction
import cz.muni.pv239.wishlist.database.entities.SharedWishlistItemEntity

@Dao
interface SharedWishlistItemDao {

    @Transaction
    fun update(entity: SharedWishlistItemEntity) {
        val savedEntity = getById(entity.idMobile)
        entity.wishlistId = savedEntity.wishlistId
        save(entity)
    }

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    fun save(entity: SharedWishlistItemEntity)

    @Query("SELECT * FROM shareditem where idMobile = :id")
    fun getById(id: Long): SharedWishlistItemEntity
}