package cz.muni.pv239.wishlist.database.entities

import androidx.room.Entity
import androidx.room.ForeignKey
import androidx.room.PrimaryKey

@Entity(tableName = "SharedItem",
    foreignKeys = [
        ForeignKey(
            entity = SharedWishlistEntity::class,
            parentColumns = arrayOf("idMobile"),
            childColumns = arrayOf("wishlistId"),
            onDelete = ForeignKey.CASCADE
        )
    ])
data class SharedWishlistItemEntity(
    @PrimaryKey(autoGenerate = true)
    val idMobile: Long,
    val idServer: String,
    var wishlistId: Long,
    val name: String,
    val desc: String,
    val isBought: Boolean
)