package cz.muni.pv239.wishlist.database.repository

import android.content.Context
import cz.muni.pv239.wishlist.database.WishlistDatabase
import cz.muni.pv239.wishlist.database.daos.MyWishlistDao
import cz.muni.pv239.wishlist.database.repository.mappers.toAppData
import cz.muni.pv239.wishlist.database.repository.mappers.toEntity
import cz.muni.pv239.wishlist.model.mywishlist.MyWishlist

class MyWishlistRepository(
    context: Context,
    private val dao: MyWishlistDao = WishlistDatabase.create(context).myWishlistDao()
) {


    fun saveOrUpdate(myWishlist: MyWishlist) {
        dao.save(myWishlist.toEntity())
    }

    fun saveOrUpdate(myWishlistList: List<MyWishlist>) {
        dao.save(myWishlistList.map { it.toEntity()})
    }

    fun delete(myWishlist: MyWishlist) {
        dao.delete(myWishlist.toEntity())
    }

    fun delete(myWishlistList: List<MyWishlist>) {
        dao.delete(myWishlistList.map { it.toEntity()})
    }

    fun deleteAll() {
        dao.deleteAll()
    }

    fun getAll(): List<MyWishlist> {
        return dao.getAll().map { it.toAppData() }.toMutableList()
    }

    fun getById(id: Long): MyWishlist {
        return dao.getById(id).toAppData()
    }

}