package cz.muni.pv239.wishlist.database.repository.mappers

import cz.muni.pv239.wishlist.database.entities.MyWishlistEntity
import cz.muni.pv239.wishlist.database.entities.SharedWishlistItemEntity
import cz.muni.pv239.wishlist.database.entities.SharedWishlistEntity
import cz.muni.pv239.wishlist.database.entities.SharedWishlistWithItems
import cz.muni.pv239.wishlist.model.mywishlist.MyWishlist
import cz.muni.pv239.wishlist.model.sharedwishlist.SharedItem
import cz.muni.pv239.wishlist.model.sharedwishlist.SharedWishlist


fun MyWishlistEntity.toAppData(): MyWishlist =
    MyWishlist(
        idMobile, idServer, name, desc, isHidden, isBought
    )

fun MyWishlist.toEntity(): MyWishlistEntity =
    MyWishlistEntity(
        idMobile, idServer, name, desc, _isHidden, _isBought
    )

fun SharedWishlistWithItems.toAppData(): SharedWishlist =
    SharedWishlist(
        wishlist.idMobile, wishlist.idServer, wishlist.controlSum, wishlist.name, items.map { it.toAppData() }
    )

fun SharedWishlistEntity.toAppData(): SharedWishlist =
    SharedWishlist(
        idMobile, idServer, controlSum, name, mutableListOf()
    )

fun SharedWishlist.toEntity(): SharedWishlistEntity =
    SharedWishlistEntity(
        idMobile, idServer, controlSum, name
    )

fun SharedWishlistItemEntity.toAppData(): SharedItem =
    SharedItem(
        idMobile, idServer, name, desc, isBought
    )

fun SharedItem.toEntity(wishlistId: Long): SharedWishlistItemEntity =
    SharedWishlistItemEntity(
        idMobile, idServer, wishlistId, name, desc, _isBought
    )

fun SharedItem.toEntity(): SharedWishlistItemEntity =
    SharedWishlistItemEntity(
        idMobile, idServer, 0L, name, desc, _isBought
    )
