package cz.muni.pv239.wishlist.restclient

import cz.muni.pv239.wishlist.model.mywishlist.MyWishlist
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.POST
import retrofit2.http.Query

interface MyWishlistService {

    @POST("myWishlist")
    fun saveOrUpdateMyWishlist(
        @Body myWishlist: MyWishlist,
        @Header("Control-Sum") controlSum: Int,
        @Header("User-UUID") user_uuid: String
    ): Call<MyWishlist>

    @DELETE("myWishlist")
    fun deleteMyWishlist(
        @Query(value = "id") id: String,
        @Header("Control-Sum") controlSum: Int,
        @Header("User-UUID") user_uuid: String
    ): Call<Void>

    @GET("myWishlist")
    fun getAllMyWishlist(
        @Header("User-UUID") user_uuid: String
    ): Call<List<MyWishlist>>
}