package cz.muni.pv239.wishlist.restclient

import cz.muni.pv239.wishlist.model.mywishlist.SharingWishlistWrapper
import cz.muni.pv239.wishlist.model.sharedwishlist.SharedItem
import cz.muni.pv239.wishlist.model.sharedwishlist.SharedWishlist
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.POST
import retrofit2.http.PUT
import retrofit2.http.Query

interface SharedItemService {
    @POST("item")
    fun update(
        @Body item: SharedItem,
        @Header("Control-Sum") controlSum: Int,
        @Header("User-UUID") user_uuid: String
    ): Call<SharedItem>

    @POST("item/add")
    fun addSharedWishlistToUser(
        @Body SharingListWrapper: SharingWishlistWrapper,
        @Header("User-UUID") user_uuid: String
    ): Call<Void>

    @DELETE("item")
    fun delete(
        @Query(value = "id") id: String,
        @Header("User-UUID") user_uuid: String
    ): Call<Void>

    @GET("item")
    fun getAll(
        @Header("User-UUID") user_uuid: String
    ): Call<List<SharedWishlist>>
}