package cz.muni.pv239.wishlist.ui.sharedwishlists.adapters

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import cz.muni.pv239.wishlist.databinding.ItemSharedWishlistBinding
import cz.muni.pv239.wishlist.model.sharedwishlist.SharedWishlist

class SharedWishlistsAdapter(
    private val onClickListenerDetail: (Long, Int) -> Unit
) : ListAdapter<SharedWishlist, SharedWishlistViewHolder>(SharedWishlistDiffUtil()) {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): SharedWishlistViewHolder =
        SharedWishlistViewHolder(
            ItemSharedWishlistBinding
                .inflate(LayoutInflater.from(parent.context), parent, false),
            onClickListenerDetail
        )

    override fun onBindViewHolder(holder: SharedWishlistViewHolder, position: Int) {
        val item = getItem(position)
        holder.bind(item)
    }
}

class SharedWishlistViewHolder(
    private val binding: ItemSharedWishlistBinding,
    private val onClickListenerDetail: (Long, Int) -> Unit
) : RecyclerView.ViewHolder(binding.root) {

    fun bind(item: SharedWishlist) {
        binding.sharedWishlistName.text = item.name
        binding.sharedWishlistItemCardview.setOnClickListener {
            onClickListenerDetail(item.idMobile, item.controlSum)
        }
    }
}

class SharedWishlistDiffUtil : DiffUtil.ItemCallback<SharedWishlist>() {
    override fun areItemsTheSame(oldItem: SharedWishlist, newItem: SharedWishlist): Boolean =
        oldItem.idMobile == newItem.idMobile

    override fun areContentsTheSame(oldItem: SharedWishlist, newItem: SharedWishlist): Boolean =
        oldItem == newItem
}